<?php
/*
 Plugin Name: Stage6 Video Plugin
 Plugin URI: http://www.blastern.info/wp/?cat=8
 Description: Insert Syage6 videos in post using [brackets] method. 
 
 
 Based on the Youtube Brackets by Robert Buzink + Mike Thompson (heavyly modified) 
 
 Version: 1 (EN)
 Author: <Blastern>L. Laf. M.</BlasterN>
 Author URI: http://www.blastern.info/
 */

class Stage6Parser {

	function generate_tags($file, $width, $height, $autoplay = "false", $controller = "") {
	    return <<<EOD
	<object codebase="http://download.divx.com/webplayer/stage6/windows/AutoDLDivXWebPlayerInstaller.cab" height="$height" width="$width" classid="clsid:67DABFBF-D0AB-41fa-9C46-CC0F21721616">
	<param name="autoplay" value="false"><param name="src" value="$file" />
	<param name="custommode" value="Stage6" /><param name="showpostplaybackad" value="true" />
	<embed type="video/divx" src="$file" pluginspage="http://go.divx.com/plugin/download/" showpostplaybackad="false" custommode="Stage6" autoplay="$autoplay" height="$height" width="$width" />
	</object>
EOD;
	
	}
	
	function parser_callback($param) {
	
		$vars = explode(" ",$param[2]);
		list($file, $width, $height, $autoplay) = $vars;
		$file="http://video.stage6.com/".$param[1].$file;
		
		$width=empty($width) ? 400 : $width;
		$height=empty($height) ? 300 : $height;
		$autoplay= ($autoplay =! "true" && $autoplay != "false") ? "false" : $autoplay;

		switch(count($vars)) {
			case 1:
			case 2:
			case 3:
			return call_user_func(array('Stage6Parser', 'generate_tags'),$file, $width, $height);//$this->generate_tags($file, $width, $height);
			break;
			case 4:
			return call_user_func(array('Stage6Parser', 'generate_tags'),$file, $width, $height, $autoplay);
			break;
		}
	}
	
	function parser($the_content) {
		$the_content=str_replace("\\[","\\{",$the_content);
		if(strpos($the_content, "[stage6=")!==FALSE) {
			preg_match_all("/\[stage6=http:\/\/video\.stage6\.com\/([a-zA-Z0-9\-\_]) ?(.*)\]/", $the_content, $matches, PREG_SET_ORDER);
			foreach($matches as $match) { // Go through matches and replace them
				$the_content = preg_replace_callback("/\[stage6=http:\/\/video\.stage6\.com\/([a-zA-Z0-9\-\_]) ?(.*)\]/", array('Stage6Parser', 'parser_callback'), $the_content, 1);
			}
		}
		$the_content=str_replace("\\{","[",$the_content);
	    return $the_content;
	}	
	
	
}

add_filter('the_content', array('Stage6Parser', 'parser'));

/**
* README :)
* KISS. KEEP IT SIMPLE STUPID!
*
* [stage6=(video url) (width) (height) (autoplay)]
* ex: [stage6=http://video.stage6.com/1285972/.divx] // video size: 400x300
* ex: [stage6=http://video.stage6.com/1285972/.divx 640] // video size: 640x300
* ex: [stage6=http://video.stage6.com/1285972/.divx 640 368] // video size: 640x368
*
* enjoy.
*/
?>